                     Samba 2.0.7 での新規事項
                     ========================

このバージョンのSambaシステムは、最新の安定版のリリースです。
現在、バグ修正を行っているバージョンのSambaシステムです。

2.0.7での新しい文書
-------------------

O'Reilly and Associatesが著作権もつ「Using Samba」がSambaコミュニティ
に寄贈されました。これはSambaソフトウェアにあわせて更新されました。
Sambaソフトウェアとともに、html形式の「Using Samba」が Sambaのオンライ
ン文書として配布されます。

SWAT(Samba Web Administration Tool)が更新されました。
SWATの起動時の画面に「Using Samba」へのリンクが加えられました。

「Using Samba」の添付により、その他の文書(とくにマニュアルページ)が破
棄されることはありません。Samba Teamは今後も、Sambaに同梱される文書の
*全て*を改良し更新していきます。

「Using Samba」のソースコードが、(生のHTMLファイルではなく)管理しやす
い形式になったため、本文書に関心をもつ人々が編集できるように努力してい
ます。

現在のところ、「Using Samba」はHTML形式でSambaソフトウェアと一緒に配布
されていますが、これは「Using Samba」をSambaソフトウェアに統合する最初
の試みであって、決してこれが唯一の配布方法になる訳ではありません(HTML
形式で配布する方法はこの書物を2.0.7に統合するもっとも手早い方法でした)。

Windows 2000 について
-----------------

このバージョンのSambaはWindows 2000に対しても試験されています。

5つの明らかになっているWindows 2000との非互換性の問題点が修正されました。
詳細は、以下の「2.0.7での変更点」を参照してください。

2.0.7で変更，または新たに加えられたパラメ−タ(smb.conf)
--------------------------------------------------------

autoconfによる"./configure"スクリプトに新しいオプションが追加されまし
た。"--with-utmp"(および "--without-utmp")オプションです。
このオプションを有効にして configure を行なうことにより、smbdはSambaサー
バーへのログオンとログオフをutmpを使って記録するようになります。

smb.confには5つの新しいパラメータが追加されました。

utmp
utmp dir
utmp hostname
utmp consolidate
wtmp directory

これらのパラメータは"--with-utmp"オプションで configure された場合にの
み有効です。
真偽値オプションのutmpパラメータにより、utmpレコードにユーザーのSamba
サーバのログオンとログオフが記録されるかどうかが制御されます。規定値は
"no" です。"utmp dir"と"wtmp dir"はutmp/wtmpデータベースが置かれている
ディレクトリのパスを指定する文字列パラメータです。
詳細はsmb.confのマニュアルページを参照して下さい。

inherit permissions

このパラメータにより、新規に作成されたファイルとディレクトリが作成時に
パーミッションを親ディレクトリから引き継ぐようになります。
これはディレクトリの階層に setgid を設定するようなことを行ないたい場合
に非常に便利です。詳細はsmb.confのマニュアルページを参照してください。

write cache size

この整数型パラメータ(バイト単位)は、smbdがoplockされたファイル毎に対し
て作成する、ユーザ毎のファイル単位の書込みキャッシュの容量を設定します。
これにより、多数の小さなサイズのファイルへの書き込みが行われたときに，
ファイルの書込みのパフォーマンスを驚異的に改善します。
このパラメータをRAIDのボリュームのストライプサイズに設定すれば（規定値
はゼロでライトキャッシュを行わない)書き込みがより効率的に行なわれるで
しょう。smbdでは最大10個のライトキャッシュを同時に有効にすることができ
ます(最初の10個のファイルに対して作成されます)。

ユーザー単位のデータのキャッシングに関するすべての一般的な注意事項が当
てはまります。詳細はsmb.confのマニュアルページを参照してください。

source environment 

このパス形式のパラメータは、Sambaが起動時に指定されたファイルから環境
変数の値を読み込むようにします。これはクラスタ環境でSambaを設定するの
に役に立つでしょう。詳細はsmb.confのマニュアルページを参照してください。

ユ−ザ−削除機能の追加
----------------------

SWATとsmbpasswdがSambaのsmbpasswdファイルからユ−ザ−を削除できるよう
になりました。詳細はsmbpasswdのマニュアルペ−ジを参照して下さい。

移動プロファイル機能の仕様確定
------------------------------

2.0.6で導入された移動プロファイルの仕様("logon path"パラメータの代わり
に"logon home"パラメータを使用する)は、Windows NTの仕様とは異なること
が判明したので、デフォルトの動作としてそのまま残されました。
詳細はsmb.confのマニュアルページ中の"logon home"パラメータに関する記述
の追加箇所を参照して下さい。

2.0.7での変更点
-----------------

1). SGI IRIX 6.5.x 上でgccを用いて、Sambaをコンパイルしたときのセマフォの
実行の問題に修正が行われました.

2). Veritas filesystemへのQUOTAサポ−トがDavid Leeにより追加されました。

3)クライアントからの多重化されたプロトコル・データ・ユニットの要求を
サポ−トする入力部分のリモートプリシージャのコ−ドが書き直されました。

4). 頻繁に使用される関数が、Ying Chen @IBMにより、インラインコード化されました。
これによりCPUの使用時間が10%削減されます。

5). キャッシュされたファイルのエントリ−の検索に、ハッシュテ−ブルを用いるように
Ying Chen@IBMにより修正が行われました。ハッシュテーブルによる検索は、
以前の連結リストにより検索を行っていたコードを格段に改良したものです。

6). smbclientの多言語サポ−トの問題点が修正されました。
現在、smbclientはlibsmb ライブラリと通信する時に、使用している
UNIXの文字セットを使用しています。

7). サイズがゼロのファイルを書き出す場合に、smbclientがエラ−メッセ−ジを
表示しない問題が修正されました。

8). smbclientの空白文字を含むファイル名の取り扱いが修正されました。

9). smbclientのブラウズリストを取得したさいに、エラーが発生した場合の
ログメッセージが改良されました。

10). すべてのSambaのコ−ドとツ−ルでNetBIOS "scope"がサポ−トされるようになりました。

11). 新たにUNIX 文字セット"roman8"がコードページ 850変換されました。

12). デバッグファイルハンドルがオ−プン出来ない場合に異常終了するバグを修正しました。

13). ディレクトリを作成する時に、最上位の階層のディレクトリの許可属性をデフォルトで
設定することが許可されていないUNIXホストで、問題なく設定されてしまう問題を修正しました。

14). グル−プ配列が動的にsetgroupsに割り当てられるように修正しました。
ヘッダファイルで正確に定義された状態のNGROUPS_MAXに依存しないようにしないようにして下さい.

15). snprintfが浮動小数点を取り扱う時に異常終了するバグが修正されました。

16). "Safe" version of popen() included to allow use in code such as "source environment" patch.

17). Fix for SWAT for trailing '\n' in asctime().

18). Wildcard match fix from weidel@multichatr.de for NT Wildcard processing.

19). unix_mask_match fixed for "veto files" parameter.

20). Linuxカーネル2.0.xにてglibc2.1.xを使っている環境で configure する時に、
システムコ−ルでバグが発生する問題が修正されました。

21). HPUX 用にSO_REUSEPORTソケットオプションが加えられました。

22). すべてのrecv()呼び出しがread()に戻されました。Solaris 2.5.xで発生するバグに対応するために行われました。

23). UNICODEの変換機構がいくつか修正されました。現在進行中の作業です。

24). NetShareEnum fix for Windows 2000. Don't ask for 64K as Win2k can't cope with this (returns "Out of memory" error").

25). cli_error()で異常終了するバグを修正しました。

26). NetBIOS名でなくDNS名を使用してパスワ−ド・サーバに接続した時に異常終了するバグを修正しました。

27). Fix bug in demangling of comacted NetBIOS names.

28). Fixed for slow locking code for VMS.

29). Reply to short NetLogon packet in nmbd with short reply.

30). Correctly allign userdata to prevent crashes in nmbd.

31). 文字列バッファの繰り返されるコードでオーバーライトしないようにtalloc()を用いました。。

32). パラメ−タをロードするコードにマルチバイトへの配慮が加えられました。

33). パスワ−ドファイルの修正コ−ドが書き直されました。原子的にユーザを削除できます。
オリジナルのパッチは、Bruce Tenisonによるものです。

34). smbpasswdタイプへの加入を振り分ける時のバグを修正しました。

35). HPによりWindowsレジストリに関するRPCのエミュレ−ションが修正され
ました。

36). リモートプロシージャコールの完璧でないプロトコルデータユニットに"unknown calls"を返す
可能性が加えられました。Windows 2000がUNIXの許可属性ををWindows  NTアクセスコントロールリスト
として返すことが許される必要があります。

37). T.D.Lee@durham.ac.ukが作成したutmpのパッチコードが採用されました。すべ
てのプラットホームで使用可能ではありませんので、./configureコマンドで試験して下
さい。

38). David Leeによりパーミッションの継承に修正が行われました。

39). 便宜的ロックされたファイルをライトキャッシュするコードが加えられました。

40). Windows 2000における新しいバグをくまなく検証しました。内容としては、
NTtransactコールを用いたNTファイル作成がUNICODEフラグビットを立てる考慮なしに
UNICODE送信を呼び出すことです。

41). Windows 2000で発生した、新しいバグが検証されました。
具体的には、アクセスコントロールリストをリードオンリーの状態に、
既存のアクセスコントロールリストを書き込みなおすバグが検証されました。

42). 使われていない mmapコードが取り除かれました。 

43). 共有モードの拒否テーブル(訳者注:"deny table")の正しいインプリメントが
なされました。Windows NTと同等になりました。

44). グループ一覧における再帰処理バグを修正しました。

45).Bjart KvarmeによりPDCからBDCへ更新されない、変更されたマシンのパスワード
のアカウントを取り込む修正が行われました。

46).Correctly skip two byte length field when accepting RPC "start of message" packets in SMBwriteX on pipes.

47). Windows 2000クライアントを自動認識するようになりました。

48).Fix bug with rollback of POSIX locks if a lock in a range fails to apply.

49).全体の一部分を構成する一部分のファイルでのsmbdの開始を書き込むことについて
のバグを修正しました。

50).DOSコードページとUNIX文字セットの間で、ユーザ名が正しく変換されるように修正されました。

51).ファイルをコピーした時にファイルの日時が誤って設定される問題が、Paul Eggertにより修正されました。

52). make_printdefでHPの特定のプリンタ定義に関するバグを修正しました。

53). Christoph PfistererによりsmbclientがOS/2 Server上の多数のファイル
が存在するディレクトリ上で'ls'を行う際の問題点が修正されました。

54).Fix for WINS server code where "do you still want name?" request was being sent to the wrong IP address.

55). "申し分なく特定されて繰り返されこと"(訳者注:"recursion desired")bitが
nmbdに設定されたのでSambaはWindows NTにほぼ同等です。

56). nmbdが、Windows 95、Windows 98およびWindows NT の両方のバージョンからの
ログオンパケットも処理するようになりました。

57). 最初のtrans2の応答の際にパラメータのオフセット値がて正しく設定されるようになりました。

58). Windows 2000は、UNICODE形式のボリュームラベルのみ、受け入れるようになるだろう。

59). nmbdが名前を登録するときに、ループバックインタフェースを登録しないようにしました。

60). Fixef bug where smbd didn't return '.' or '..' on top level share directory listing.

61). Fix for soft quotas not being set (make them equal to hardquota)

from Norbert Pchel (Pueschel.Norbert@Walzbarren-VAW.ne.uunet.de).

62). SWAT fixes for SCO Unixware (SIGPIPE handling).

63). Fix for nmbd DOS with redirect recursion.

64). ログファイルが制限なしに大きくなる問題がMattias Gronlundにより修正さ
れました。

65). Fix for smbd crash bug in truncate is locked.

66).  mangle nameコードでのメモリーリークの問題が修正されました。
